#include <boarddefs.h>
#include <Servo.h>
#include <IRremote.h>
#include <IRremoteInt.h>

int NulevoiUgol = 45;     // примерно 45
int pin_servo1  = 10;     // пин сервомашинки на пилоне
int RECV_PIN    = 11;     // пин ИК приемника сигнала с пульта
int MotorPlus   = 6;      // пин питания мотора
int MotorNul    = 7;      // нудевой пин мотора (минус)
Servo servo1;             // объявляем переменную типа servo
IRrecv irrecv(RECV_PIN);  // создаем объект получения сигнала с ИК порта
decode_results results;   // переменная хранящая результат полученный с ИК порта


void setup() {
  Serial.begin(9600);                      // задаем скорость работы порта для просмотра ИК кода
  servo1.attach(pin_servo1);               // включаем сервопривод
  irrecv.enableIRIn();                     // включаем ИК-приемник
  pinMode(MotorPlus, OUTPUT);              // назначаем пин потору
  pinMode(MotorNul, OUTPUT);               // назначаем второй пин мотору
  servo1.write(NulevoiUgol);               // ставим пилон прямо
  delay (100);                             // даем время пилону повернуться
  digitalWrite(MotorNul, LOW);             // ноль на второй провод мотора
}

void loop() {
  if (irrecv.decode(&results))             // если есть сигнал c пульта
  {
    Serial.println(results.value);         // показываеи код кнопки
    if (results.value == 16718055)         // вперед
    {
      digitalWrite(MotorPlus, LOW);        // выключаем мотор чтобы повернуть пилон
      delay (100);                         // пауза перед поворотом
      servo1.write(NulevoiUgol);           // поворачиваем пилон прямо
      delay (100);                         // даем время пилону повернуться
      digitalWrite(MotorPlus, HIGH);       // снова включаем мотор
      Serial.println("vpered");
    }
    if (results.value == 16726215)         // стоп
    {
      digitalWrite(MotorPlus, LOW);        // выключаем мотор
      digitalWrite(MotorNul, LOW);
      Serial.println("stop");
    }
    if (results.value == 16734885)          // направо
    {
      digitalWrite(MotorPlus, LOW);         // выключаем мотор чтобы повернуть пилон
      delay (100);                          // пауза перед поворотом
      servo1.write(NulevoiUgol + 20);       // поворачиваем пилон
      delay (100);                          // даем время пилону повернуться
      digitalWrite(MotorPlus, HIGH);        // снова включаем мотор вперед
      Serial.println("napravo");
    }
    if (results.value == 16716015)          // налево
    {
      digitalWrite(MotorPlus, LOW);         // выключаем мотор чтобы повернуть пилон
      delay (100);                          // пауза перед поворотом
      servo1.write(NulevoiUgol - 20);       // поворачиваем пилон
      delay (100);                          // даем время пилону повернуться
      digitalWrite(MotorPlus, HIGH);        // снова включаем мотор вперед
      Serial.println("nalevo");
    }
    irrecv.resume();                        // получаем следующее значение с пульта
  }
}
